//	DTMFo

#include <windows.h>
#include <tchar.h>
#include <mmsystem.h>
#include <math.h>
#include "resource.h"

#pragma comment(lib,"winmm.lib")

#ifndef M_PI
	#define M_PI 3.14159265358979323846
#endif

//	_CAO{bNXvV[W[
LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam);

//	LN^[R[hɑΉDTMFM̎g擾
void Char2Dtmf(int c, int* f1, int* f2);

class OUT_WAVE{
	int bufCount;	//	ĐoCg
	int sz;			//	obt@
	HWAVEOUT hWaveOut;
	WAVEFORMATEX wfe;
	WAVEHDR* whdr;
	short** lpWave;	//	obt@
public:
	bool reset;
	void open2(int rate, int sec){	//	waveo̓foCXJ
		bufCount = 1;	//	gpobt@
		reset = true;
		wfe.wFormatTag = WAVE_FORMAT_PCM;
		wfe.nChannels = 1;	//	m	
		wfe.wBitsPerSample = 16;	//	\16bit
		wfe.nBlockAlign = wfe.nChannels*wfe.wBitsPerSample / 8;
		wfe.nSamplesPerSec = rate;	//	Tv[g
		wfe.nAvgBytesPerSec = wfe.nSamplesPerSec * wfe.nBlockAlign;
		waveOutOpen(&hWaveOut, WAVE_MAPPER, &wfe, (DWORD_PTR)0, (DWORD_PTR)this, CALLBACK_FUNCTION);
		sz = wfe.nAvgBytesPerSec*sec/1000;
		whdr =new WAVEHDR[bufCount];
		lpWave = (short**)new DWORD_PTR[bufCount];
		for (int n = 0; n < bufCount; n++){
			lpWave[n] = new short[wfe.nAvgBytesPerSec*sec];
			whdr[n].lpData = (LPSTR)lpWave[n];
		}
	}
	void dtmfMake(int freq1,int freq2){	//	DTMFf[^쐬
		double qstep1 = 2 * M_PI *freq1 / wfe.nSamplesPerSec;
		double qstep2 = 2 * M_PI *freq2 / wfe.nSamplesPerSec;
		double q1 = 0;
		double q2 = 0;
		int n;
		for (n = 0; n < sz; n++){
			int d;
			d = int(16383 * sin(q1)) + int(16383 * sin(q2));
			for (int i = 0; i < bufCount; i++)
				lpWave[i][n] = d;
			q1 += qstep1;
			q2 += qstep2;
		}
		for (int i = 0; i < bufCount; i++){
			whdr[i].dwBufferLength = n * 2;	//	obt@oCg
			whdr[i].dwFlags = WHDR_BEGINLOOP | WHDR_ENDLOOP;
			whdr[i].dwLoops = 0;
			whdr[i].dwUser = 0;
		}
	}
	void ownPlay(void){	//	VbgĐ
		reset = true;
		for (int i = 0; i < bufCount; i++){
			whdr[i].dwLoops = 0;
			whdr[i].dwFlags = 0;
			waveOutPrepareHeader(hWaveOut, &whdr[i], sizeof(WAVEHDR));
			waveOutWrite(hWaveOut, &whdr[i], sizeof(WAVEHDR));
		}
	}
	void stop(void){	//	~
		reset = true;
		waveOutReset(hWaveOut);
	}
	void close(void){	//	waveo̓foCX
		stop();
		for (int n = 0; n < bufCount; n++){
			waveOutUnprepareHeader(hWaveOut, &whdr[n], sizeof(WAVEHDR));
			delete[]lpWave[n];
		}
		delete[]whdr;
		delete[]lpWave;
	}
};

OUT_WAVE wav;

int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE hPreInst, TCHAR* lpszCmdLine, int nCmdShow){
	wav.open2( 48000 , 200 );
	DialogBox(hInstance, TEXT("DLG1"), 0, (DLGPROC)DlgProc1);
	wav.close();
	return 0;
}

//	_CAO{bNXvV[W[

LRESULT CALLBACK DlgProc1(HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam){
	int freq1;
	int freq2;
	switch (msg) {

	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDCANCEL:
			EndDialog(hDlg, FALSE);
			return FALSE;
		default:
			if (isDtmfChar(LOWORD(wParam) - WM_USER) ){
				wav.stop();
				Char2Dtmf(LOWORD(wParam) - WM_USER,&freq1,&freq2);
				wav.dtmfMake(freq1,freq2);
				wav.ownPlay();
			}
			return FALSE;
		}
	default:
		return FALSE;
	}
	return TRUE;
}

//	LN^[R[hɑΉDTMFM̎g擾

void Char2Dtmf(int c, int* f1, int* f2){
	int low[] = { 697, 770, 852, 941 };
	int hi[] = { 1209, 1336, 1477, 1633 };
	char* str = "123A456B789C*0#D";

	int n = 0;
	while (str[n]){
		if (str[n] == c){
			int hin = n % 4;
			int lown = n / 4;
			*f1 = low[lown];
			*f2 = hi[hin];
			return;
		}
		++n;
	}
	*f1 = -1;
	*f2 = -1;
}
